OpMath

com.opmath.util.http
Class HttpServletRequest

java.lang.Object
  |
  +--com.opmath.util.http.HttpServletRequest
All Implemented Interfaces:
HttpServletRequest, ServletRequest

public class HttpServletRequest
extends Object
implements HttpServletRequest

Implements the javax.servlet.ServletRequest and javax.servlet.http.HttpServletRequest interfaces to provide request information for servlets that subclass com.opmath.util.HttpServlet.

The servlet container creates an HttpServletRequest object and passes it as an argument to the com.opmath.util.http.HttpServlet service methods (doGet, doPost). The specialised service methods (doGetDispatch, doPostDispatch) are passed an com.opmath.util.http.HttpServletRequest object, in place of the orginal javax.servlet.http.HttpServletRequest object.

Copyright: (c) 2002 The Open Math Company Limited

The Terms of Distribution of this software are stipulated in the javadoc Overview for this project.

Since:
J2SE 1.3.0
Version:
utilities-v011
Author:
Bruno Beloff bruno.beloff@opmath.com
See Also:
HttpServlet

Field Summary
 
Fields inherited from interface javax.servlet.http.HttpServletRequest
BASIC_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH, FORM_AUTH
 
Constructor Summary
HttpServletRequest(HttpServletRequest request)
          Constructs a new com.opmath.util.http.HttpServletRequest object.
 
Method Summary
 Object getAttribute(String name)
          Returns the value of the named attribute as an Object, or null if no attribute of the given name exists.
 Enumeration getAttributeNames()
          Returns an Enumeration containing the names of the attributes available to this request.
 String getAuthType()
          Returns the name of the authentication scheme used to protect the servlet.
 Boolean getBooleanParameter(String paramName)
          Returns the value of a request parameter as a Boolean.
 String getCharacterEncoding()
          Returns the name of the character encoding used in the body of this request.
 int getContentLength()
          Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known.
 String getContentType()
          Returns the MIME type of the body of the request, or null if the type is not known.
 String getContextPath()
          Returns the portion of the request URI that indicates the context of the request.
 Cookie[] getCookies()
          Returns an array containing all of the Cookie objects the client sent with this request.
 long getDateHeader(String name)
          Returns the value of the specified request header as a long that represents a Date object.
 Double getDoubleParameter(String paramName)
          Returns the value of a request parameter as a Double.
 Float getFloatParameter(String paramName)
          Returns the value of a request parameter as a Float.
 String getHeader(String name)
          Returns the value of the specified request header as a String.
 Enumeration getHeaderNames()
          Returns an Enumeration of all the header names this request contains.
 Enumeration getHeaders(String name)
          Returns all the values of the specified request header as an Enumeration of String objects.
 ServletInputStream getInputStream()
          Retrieves the body of the request as binary data using a ServletInputStream.
 Integer getIntegerParameter(String paramName)
          Returns the value of a request parameter as a Integer.
 int getIntHeader(String name)
          Returns the value of the specified request header as an int.
 Locale getLocale()
          Returns the preferred Locale that the client will accept content in, based on the Accept-Language header.
 Enumeration getLocales()
          Returns an Enumeration of Locale objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header.
 Long getLongParameter(String paramName)
          Returns the value of a request parameter as a Long.
 String getMethod()
          Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT.
 String getParameter(String name)
          Returns the value of a request parameter as a String, or null if the parameter does not exist.
 Map getParameterMap()
          Returns a java.util.Map of the parameters of this request.
 Enumeration getParameterNames()
          Returns an Enumeration of String objects containing the names of the parameters contained in this request.
 String[] getParameterValues(String name)
          Returns an array of String objects containing all of the values the given request parameter has, or null if the parameter does not exist.
 String getPathInfo()
          Returns any extra path information associated with the URL the client sent when it made this request.
 String getPathTranslated()
          Returns any extra path information after the servlet name but before the query string, and translates it to a real path.
 String getProtocol()
          Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1.
 String getQueryString()
          Returns the query String that is contained in the request URL after the path.
 BufferedReader getReader()
          Retrieves the body of the request as character data using a BufferedReader.
 String getRealPath(String path)
          Deprecated. As of Version 2.1 of the Java Servlet API, use ServletContext.getRealPath(java.lang.String) instead.
 String getRemoteAddr()
          Returns the Internet Protocol (IP) address of the client that sent the request.
 String getRemoteHost()
          Returns the fully qualified name of the client that sent the request, or the IP address of the client if the name cannot be determined.
 String getRemoteUser()
          Returns the login of the user making this request, if the user has been authenticated, or null if the user has not been authenticated.
 RequestDispatcher getRequestDispatcher(String path)
          Returns a RequestDispatcher object that acts as a wrapper for the resource located at the given path.
 String getRequestedSessionId()
          Returns the session ID specified by the client.
 String getRequestURI()
          Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request.
 StringBuffer getRequestURL()
          Reconstructs the URL the client used to make the request.
 String getScheme()
          Returns the name of the scheme used to make this request, for example, http, https, or ftp.
 String getServerName()
          Returns the host name of the server that received the request.
 int getServerPort()
          Returns the port number on which this request was received.
 String getServletPath()
          Reconstructs the URL the client used to make the request.
 HttpSession getSession()
          Returns the current session associated with this request, or if the request does not have a session, creates one.
 HttpSession getSession(boolean create)
          Returns the current HttpSession associated with this request or, if if there is no current session and create is true, returns a new session.
 Short getShortParameter(String paramName)
          Returns the value of a request parameter as a Long.
 String getStringParameter(String paramName)
          Returns the value of a request parameter as a String.
 Principal getUserPrincipal()
          Returns a java.security.Principal object containing the name of the current authenticated user.
 boolean isRequestedSessionIdFromCookie()
          Checks whether the requested session ID came in as a cookie.
 boolean isRequestedSessionIdFromUrl()
          Deprecated. As of Version 2.1 of the Java Servlet API, use isRequestedSessionIdFromURL() instead.
 boolean isRequestedSessionIdFromURL()
          Checks whether the requested session ID came in as part of the request URL.
 boolean isRequestedSessionIdValid()
          Checks whether the requested session ID is still valid.
 boolean isSecure()
          Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.
 boolean isUserInRole(String role)
          Returns a boolean indicating whether the authenticated user is included in the specified logical "role".
 void removeAttribute(String name)
          Removes an attribute from this request.
 void setAttribute(String name, Object o)
          Stores an attribute in this request.
 void setCharacterEncoding(String env)
          Overrides the name of the character encoding used in the body of this request.
 
Methods inherited from class java.lang.Object
clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait
 
Methods inherited from interface javax.servlet.http.HttpServletRequest
 

Constructor Detail

HttpServletRequest

public HttpServletRequest(HttpServletRequest request)

Constructs a new com.opmath.util.http.HttpServletRequest object. The com.opmath.util.http.HttpServletRequest works by delegation, passing method calls specified by the javax.servlet.ServletRequest and javax.servlet.http.HttpServletRequest interfaces to the object given to this constructor.

Since:
J2SE 1.3
Method Detail

getBooleanParameter

public Boolean getBooleanParameter(String paramName)
                            throws ParameterAbsentException,
                                   ParameterFormatException

Returns the value of a request parameter as a Boolean. If the parameter was absent, or no value was given for the parameter, then a ParameterAbsentException is thrown. If the parameter value is present, but cannot be parsed as a Boolean, then a ParameterFormatException is thrown.

Note that the rules used by this method for parsing a Boolean parameter are different to those used by Java. Specifically, the rules are (ignoring parameter value case):

Paremeter ValueReturned Value
truetrue
yestrue
falsefalse
nofalse
all other valuesParameterFormatException thrown

Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

You should only use this method when you are sure the parameter has only one value. If the parameter might have more than one value, use getParameterValues(java.lang.String). If you use this method with a multivalued parameter, the value returned is equal to the first value in the array returned by getParameterValues.

If the parameter data was sent in the request body, such as occurs with an HTTP POST request, then reading the body directly via getInputStream() or getReader() can interfere with the execution of this method

Returns:
A Boolean carrying the value of the parameter.
Throws:
ParameterAbsentException - if the parameter was not present.
ParameterFormatException - if the parameter value was malformed.
ParameterAbsentException
ParameterFormatException
Since:
J2SE 1.3
See Also:
getDoubleParameter(String), getFloatParameter(String), getIntegerParameter(String), getStringParameter(String)

getDoubleParameter

public Double getDoubleParameter(String paramName)
                          throws ParameterAbsentException,
                                 ParameterFormatException

Returns the value of a request parameter as a Double. If the parameter was absent, or no value was given for the parameter, then a ParameterAbsentException is thrown. If the parameter value is present, but cannot be parsed as a Double, then a ParameterFormatException is thrown.

Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

You should only use this method when you are sure the parameter has only one value. If the parameter might have more than one value, use getParameterValues(java.lang.String). If you use this method with a multivalued parameter, the value returned is equal to the first value in the array returned by getParameterValues.

If the parameter data was sent in the request body, such as occurs with an HTTP POST request, then reading the body directly via getInputStream() or getReader() can interfere with the execution of this method

Returns:
A Double carrying the value of the parameter.
Throws:
ParameterAbsentException - if the parameter was not present.
ParameterFormatException - if the parameter value was malformed.
ParameterAbsentException
ParameterFormatException
Since:
J2SE 1.3
See Also:
getBooleanParameter(String), getFloatParameter(String), getIntegerParameter(String), getStringParameter(String)

getFloatParameter

public Float getFloatParameter(String paramName)
                        throws ParameterAbsentException,
                               ParameterFormatException

Returns the value of a request parameter as a Float. If the parameter was absent, or no value was given for the parameter, then a ParameterAbsentException is thrown. If the parameter value is present, but cannot be parsed as a Float, then a ParameterFormatException is thrown.

Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

You should only use this method when you are sure the parameter has only one value. If the parameter might have more than one value, use getParameterValues(java.lang.String). If you use this method with a multivalued parameter, the value returned is equal to the first value in the array returned by getParameterValues.

If the parameter data was sent in the request body, such as occurs with an HTTP POST request, then reading the body directly via getInputStream() or getReader() can interfere with the execution of this method

Returns:
A Float carrying the value of the parameter.
Throws:
ParameterAbsentException - if the parameter was not present.
ParameterFormatException - if the parameter value was malformed.
ParameterAbsentException
ParameterFormatException
Since:
J2SE 1.3
See Also:
getBooleanParameter(String), getDoubleParameter(String), getIntegerParameter(String), getStringParameter(String)

getIntegerParameter

public Integer getIntegerParameter(String paramName)
                            throws ParameterAbsentException,
                                   ParameterFormatException

Returns the value of a request parameter as a Integer. If the parameter was absent, or no value was given for the parameter, then a ParameterAbsentException is thrown. If the parameter value is present, but cannot be parsed as a Integer, then a ParameterFormatException is thrown.

Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

You should only use this method when you are sure the parameter has only one value. If the parameter might have more than one value, use getParameterValues(java.lang.String). If you use this method with a multivalued parameter, the value returned is equal to the first value in the array returned by getParameterValues.

If the parameter data was sent in the request body, such as occurs with an HTTP POST request, then reading the body directly via getInputStream() or getReader() can interfere with the execution of this method

Returns:
An Integer carrying the value of the parameter.
Throws:
ParameterAbsentException - if the parameter was not present.
ParameterFormatException - if the parameter value was malformed.
ParameterAbsentException
ParameterFormatException
Since:
J2SE 1.3
See Also:
getBooleanParameter(String), getDoubleParameter(String), getFloatParameter(String), getStringParameter(String)

getLongParameter

public Long getLongParameter(String paramName)
                      throws ParameterAbsentException,
                             ParameterFormatException

Returns the value of a request parameter as a Long. If the parameter was absent, or no value was given for the parameter, then a ParameterAbsentException is thrown. If the parameter value is present, but cannot be parsed as a Integer, then a ParameterFormatException is thrown.

Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

You should only use this method when you are sure the parameter has only one value. If the parameter might have more than one value, use getParameterValues(java.lang.String). If you use this method with a multivalued parameter, the value returned is equal to the first value in the array returned by getParameterValues.

If the parameter data was sent in the request body, such as occurs with an HTTP POST request, then reading the body directly via getInputStream() or getReader() can interfere with the execution of this method

Returns:
a Long carrying the value of the parameter.
Throws:
ParameterAbsentException - if the parameter was not present.
ParameterFormatException - if the parameter value was malformed.
ParameterAbsentException
ParameterFormatException
Since:
J2SE 1.3
See Also:
getBooleanParameter(String), getDoubleParameter(String), getFloatParameter(String), getStringParameter(String)

getShortParameter

public Short getShortParameter(String paramName)
                        throws ParameterAbsentException,
                               ParameterFormatException

Returns the value of a request parameter as a Long. If the parameter was absent, or no value was given for the parameter, then a ParameterAbsentException is thrown. If the parameter value is present, but cannot be parsed as a Integer, then a ParameterFormatException is thrown.

Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

You should only use this method when you are sure the parameter has only one value. If the parameter might have more than one value, use getParameterValues(java.lang.String). If you use this method with a multivalued parameter, the value returned is equal to the first value in the array returned by getParameterValues.

If the parameter data was sent in the request body, such as occurs with an HTTP POST request, then reading the body directly via getInputStream() or getReader() can interfere with the execution of this method

Returns:
a Short carrying the value of the parameter.
Throws:
ParameterAbsentException - if the parameter was not present.
ParameterFormatException - if the parameter value was malformed.
ParameterAbsentException
ParameterFormatException
Since:
J2SE 1.3
See Also:
getBooleanParameter(String), getDoubleParameter(String), getFloatParameter(String), getStringParameter(String)

getStringParameter

public String getStringParameter(String paramName)
                          throws ParameterAbsentException

Returns the value of a request parameter as a String. If the parameter was absent, or no value was given for the parameter, then a ParameterAbsentException is thrown.

Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

You should only use this method when you are sure the parameter has only one value. If the parameter might have more than one value, use getParameterValues(java.lang.String). If you use this method with a multivalued parameter, the value returned is equal to the first value in the array returned by getParameterValues.

If the parameter data was sent in the request body, such as occurs with an HTTP POST request, then reading the body directly via getInputStream() or getReader() can interfere with the execution of this method

Returns:
A String carrying the value of the parameter.
Throws:
ParameterAbsentException - if the parameter was not present.
ParameterAbsentException
Since:
J2SE 1.3
See Also:
getBooleanParameter(String), getDoubleParameter(String), getFloatParameter(String), getIntegerParameter(String)

getAuthType

public String getAuthType()

Returns the name of the authentication scheme used to protect the servlet. All servlet containers support BASIC_AUTH, FORM_AUTH, and CLIENT_CERT_AUTH and may support DIGEST_AUTH. If the servlet is not authenticated null is returned.

Same as the value of the CGI variable AUTH_TYPE.

Specified by:
getAuthType in interface HttpServletRequest
Returns:
A String specifying the name of the authentication scheme, or null if the request was not authenticated.
Since:
J2SE 1.3

getCookies

public Cookie[] getCookies()

Returns an array containing all of the Cookie objects the client sent with this request. This method returns null if no cookies were sent.

Specified by:
getCookies in interface HttpServletRequest
Returns:
A Cookie[] of all the Cookies included with this request, or null if the request has no cookies
Since:
J2SE 1.3

getDateHeader

public long getDateHeader(String name)

Returns the value of the specified request header as a long that represents a Date object. Use this method with headers that contain dates, such as If-Modified-Since.

The date is returned as the number of milliseconds since January 1, 1970 GMT. The header name is case insensitive.

If the request did not have a header of the specified name, this method returns -1. If the header can't be converted to a date, the method throws an IllegalArgumentException.

Specified by:
getDateHeader in interface HttpServletRequest
Returns:
A long representing the date specified in the header expressed as the number of milliseconds since January 1, 1970 GMT, or -1 if the named header was not included with the reqest.
Since:
J2SE 1.3

getHeader

public String getHeader(String name)

Returns the value of the specified request header as a String. If the request did not include a header of the specified name, this method returns null. The header name is case insensitive. You can use this method with any request header.

Specified by:
getHeader in interface HttpServletRequest
Returns:
A String a String containing the value of the requested header, or null if the request does not have a header of that name.
Since:
J2SE 1.3
See Also:
HttpServletRequest.getHeader(String)

getHeaders

public Enumeration getHeaders(String name)

Returns all the values of the specified request header as an Enumeration of String objects.

Some headers, such as Accept-Language can be sent by clients as several headers each with a different value rather than sending the header as a comma separated list.

If the request did not include any headers of the specified name, this method returns an empty Enumeration. The header name is case insensitive. You can use this method with any request header.

Specified by:
getHeaders in interface HttpServletRequest
Returns:
An Enumeration containing the values of the requested header. If the request does not have any headers of that name return an empty Enumeration. If the container does not allow access to header information, return null.
Since:
J2SE 1.3

getHeaderNames

public Enumeration getHeaderNames()

Returns an Enumeration of all the header names this request contains. If the request has no headers, this method returns an empty Enumeration.

Some servlet containers do not allow do not allow servlets to access headers using this method, in which case this method returns null.

Specified by:
getHeaderNames in interface HttpServletRequest
Returns:
An Enumeration of all the header names sent with this request; if the request has no headers, an empty Enumeration; if the servlet container does not allow servlets to use this method, null
Since:
J2SE 1.3

getIntHeader

public int getIntHeader(String name)

Returns the value of the specified request header as an int. If the request does not have a header of the specified name, this method returns -1. If the header cannot be converted to an Integer, this method throws a NumberFormatException.

The header name is case insensitive.

Specified by:
getIntHeader in interface HttpServletRequest
Returns:
An int specifying the name of a request header.
Since:
J2SE 1.3

getMethod

public String getMethod()

Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT. Same as the value of the CGI variable REQUEST_METHOD.

Specified by:
getMethod in interface HttpServletRequest
Returns:
A String specifying the name of the method with which this request was made.
Since:
J2SE 1.3

getPathInfo

public String getPathInfo()

Returns any extra path information associated with the URL the client sent when it made this request. The extra path information follows the servlet path but precedes the query string. This method returns null if there was no extra path information.

Specified by:
getPathInfo in interface HttpServletRequest
Returns:
A String decoded by the web container, specifying extra path information that comes after the servlet path but before the query string in the request URL; or null if the URL does not have any extra path information.
Since:
J2SE 1.3

getPathTranslated

public String getPathTranslated()

Returns any extra path information after the servlet name but before the query string, and translates it to a real path. Same as the value of the CGI variable PATH_TRANSLATED.

If the URL does not have any extra path information, this method returns null. The web container does not decode this string.

Specified by:
getPathTranslated in interface HttpServletRequest
Returns:
A String specifying the real path, or null if the URL does not have any extra path information.
Since:
J2SE 1.3

getContextPath

public String getContextPath()

Returns the portion of the request URI that indicates the context of the request. The context path always comes first in a request URI. The path starts with a "/" character but does not end with a "/" character. For servlets in the default (root) context, this method returns "". The container does not decode this string.

Specified by:
getContextPath in interface HttpServletRequest
Returns:
A String specifying the portion of the request URI that indicates the context of the request.
Since:
J2SE 1.3

getQueryString

public String getQueryString()

Returns the query String that is contained in the request URL after the path. This method returns null if the URL does not have a query string. Same as the value of the CGI variable QUERY_STRING.

Specified by:
getQueryString in interface HttpServletRequest
Returns:
A String containing the query string or null if the URL contains no query string. The value is not decoded by the container.
Since:
J2SE 1.3

getRemoteUser

public String getRemoteUser()

Returns the login of the user making this request, if the user has been authenticated, or null if the user has not been authenticated. Whether the user name is sent with each subsequent request depends on the browser and type of authentication. Same as the value of the CGI variable REMOTE_USER.

Specified by:
getRemoteUser in interface HttpServletRequest
Returns:
A String specifying the login of the user making this request, or null.
Since:
J2SE 1.3

isUserInRole

public boolean isUserInRole(String role)

Returns a boolean indicating whether the authenticated user is included in the specified logical "role". Roles and role membership can be defined using deployment descriptors. If the user has not been authenticated, the method returns false.

Specified by:
isUserInRole in interface HttpServletRequest
Returns:
A boolean indicating whether the user making this request belongs to a given role; false if the user has not been authenticated
Since:
J2SE 1.3

getUserPrincipal

public Principal getUserPrincipal()

Returns a java.security.Principal object containing the name of the current authenticated user. If the user has not been authenticated, the method returns null.

Specified by:
getUserPrincipal in interface HttpServletRequest
Returns:
A java.security.Principal containing the name of the user making this request; null if the user has not been authenticated.
Since:
J2SE 1.3

getRequestedSessionId

public String getRequestedSessionId()

Returns the session ID specified by the client. This may not be the same as the ID of the actual session in use. For example, if the request specified an old (expired) session ID and the server has started a new session, this method gets a new session with a new ID. If the request did not specify a session ID, this method returns null.

Specified by:
getRequestedSessionId in interface HttpServletRequest
Returns:
A String specifying the session ID, or null if the request did not specify a session ID.
Since:
J2SE 1.3

getRequestURI

public String getRequestURI()

Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request. The web container does not decode this String.

Specified by:
getRequestURI in interface HttpServletRequest
Returns:
A String containing the part of the URL from the protocol name up to the query string.
Since:
J2SE 1.3

getServletPath

public String getServletPath()

Reconstructs the URL the client used to make the request. The returned URL contains a protocol, server name, port number, and server path, but it does not include query string parameters.

Because this method returns a StringBuffer, not a String, you can modify the URL easily, for example, to append query parameters.

This method is useful for creating redirect messages.

Specified by:
getServletPath in interface HttpServletRequest
Returns:
A String containing the reconstructed URL.
Since:
J2SE 1.3
See Also:
HttpServletRequest.getServletPath()

getSession

public HttpSession getSession(boolean create)

Returns the current HttpSession associated with this request or, if if there is no current session and create is true, returns a new session.

If create is false and the request has no valid HttpSession, this method returns null.

To make sure the session is properly maintained, you must call this method before the response is committed.

Specified by:
getSession in interface HttpServletRequest
Returns:
The HttpSession associated with this request or null if create is false and the request has no valid session.
Since:
J2SE 1.3

getSession

public HttpSession getSession()

Returns the current session associated with this request, or if the request does not have a session, creates one.

Specified by:
getSession in interface HttpServletRequest
Returns:
The HttpSession associated with this request.
Since:
J2SE 1.3

isRequestedSessionIdValid

public boolean isRequestedSessionIdValid()

Checks whether the requested session ID is still valid.

Specified by:
isRequestedSessionIdValid in interface HttpServletRequest
Returns:
A boolean true if this request has an id for a valid session in the current session context; false otherwise.
Since:
J2SE 1.3

isRequestedSessionIdFromCookie

public boolean isRequestedSessionIdFromCookie()

Checks whether the requested session ID came in as a cookie.

Specified by:
isRequestedSessionIdFromCookie in interface HttpServletRequest
Returns:
A boolean true if the session ID came in as a cookie; otherwise, false.
Since:
J2SE 1.3

isRequestedSessionIdFromURL

public boolean isRequestedSessionIdFromURL()

Checks whether the requested session ID came in as part of the request URL.

Specified by:
isRequestedSessionIdFromURL in interface HttpServletRequest
Returns:
A boolean true if the session ID came in as part of a URL; otherwise, false.
Since:
J2SE 1.3

isRequestedSessionIdFromUrl

public boolean isRequestedSessionIdFromUrl()
Deprecated. As of Version 2.1 of the Java Servlet API, use isRequestedSessionIdFromURL() instead.

Specified by:
isRequestedSessionIdFromUrl in interface HttpServletRequest

getAttribute

public Object getAttribute(String name)

Returns the value of the named attribute as an Object, or null if no attribute of the given name exists.

Attributes can be set two ways:

The servlet container may set attributes to make available custom information about a request. For example, for requests made using HTTPS, the attribute javax.servlet.request.X509Certificate can be used to retrieve information on the certificate of the client.

Attributes can also be set programatically using setAttribute(java.lang.String, java.lang.Object). This allows information to be embedded into a request before a RequestDispatcher call.

Attribute names should follow the same conventions as package names. This specification reserves names matching java.*, javax.*, and sun.*.

Specified by:
getAttribute in interface ServletRequest
Returns:
An Object containing the value of the attribute, or null if the attribute does not exist.
Since:
J2SE 1.3

getAttributeNames

public Enumeration getAttributeNames()

Returns an Enumeration containing the names of the attributes available to this request. This method returns an empty Enumeration if the request has no attributes available to it.

Specified by:
getAttributeNames in interface ServletRequest
Returns:
An Enumeration of strings containing the names of the request's attributes.
Since:
J2SE 1.3

getCharacterEncoding

public String getCharacterEncoding()

Returns the name of the character encoding used in the body of this request. This method returns null if the request does not specify a character encoding.

Specified by:
getCharacterEncoding in interface ServletRequest
Returns:
A String containing the name of the chararacter encoding, or null if the request does not specify a character encoding.
Since:
J2SE 1.3

getContentLength

public int getContentLength()

Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_LENGTH.

Specified by:
getContentLength in interface ServletRequest
Returns:
An int an integer containing the length of the request body or -1 if the length is not known.
Since:
J2SE 1.3

getContentType

public String getContentType()

Returns the MIME type of the body of the request, or null if the type is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_TYPE.

Specified by:
getContentType in interface ServletRequest
Returns:
A String containing the name of the MIME type of the request, or -1 if the type is not known.
Since:
J2SE 1.3

getInputStream

public ServletInputStream getInputStream()
                                  throws IOException

Retrieves the body of the request as binary data using a ServletInputStream. Either this method or getReader() may be called to read the body, not both.

Specified by:
getInputStream in interface ServletRequest
Returns:
A ServletInputStream object containing the body of the request.
Throws:
java.lang.IllegalStateException - if the getReader() method has already been called for this request.
java.lang.IOException - if an input or output exception occurred.
IOException
Since:
J2SE 1.3

getParameter

public String getParameter(String name)

Returns the value of a request parameter as a String, or null if the parameter does not exist. Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

You should only use this method when you are sure the parameter has only one value. If the parameter might have more than one value, use getParameterValues(java.lang.String).

If you use this method with a multivalued parameter, the value returned is equal to the first value in the array returned by getParameterValues.

If the parameter data was sent in the request body, such as occurs with an HTTP POST request, then reading the body directly via getInputStream() or getReader() can interfere with the execution of this method

Specified by:
getParameter in interface ServletRequest
Returns:
A Type carrying something.
Since:
J2SE 1.3
See Also:
getBooleanParameter(String), getDoubleParameter(String), getFloatParameter(String), getIntegerParameter(String), getStringParameter(String)

getParameterNames

public Enumeration getParameterNames()

Returns an Enumeration of String objects containing the names of the parameters contained in this request. If the request has no parameters, the method returns an empty Enumeration.

Specified by:
getParameterNames in interface ServletRequest
Returns:
An Enumeration of String objects, each String containing the name of a request parameter; or an empty Enumeration if the request has no parameters.
Since:
J2SE 1.3

getParameterValues

public String[] getParameterValues(String name)

Returns an array of String objects containing all of the values the given request parameter has, or null if the parameter does not exist.

If the parameter has a single value, the array has a length of 1.

Specified by:
getParameterValues in interface ServletRequest
Returns:
A String[] containing the parameter's values.
Since:
J2SE 1.3

getProtocol

public String getProtocol()

Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1. For HTTP servlets, the value returned is the same as the value of the CGI variable SERVER_PROTOCOL.

Specified by:
getProtocol in interface ServletRequest
Returns:
A String containing the protocol name and version number.
Since:
J2SE 1.3

getScheme

public String getScheme()

Returns the name of the scheme used to make this request, for example, http, https, or ftp. Different schemes have different rules for constructing URLs, as noted in RFC 1738.

Specified by:
getScheme in interface ServletRequest
Returns:
A String containing the name of the scheme used to make this request.
Since:
J2SE 1.3

getServerName

public String getServerName()

Returns the host name of the server that received the request. For HTTP servlets, same as the value of the CGI variable SERVER_NAME.

Specified by:
getServerName in interface ServletRequest
Returns:
A String containing the name of the server to which the request was sent.
Since:
J2SE 1.3

getServerPort

public int getServerPort()

Returns the port number on which this request was received. For HTTP servlets, same as the value of the CGI variable SERVER_PORT.

Specified by:
getServerPort in interface ServletRequest
Returns:
An int an integer specifying the port number.
Since:
J2SE 1.3

getReader

public BufferedReader getReader()
                         throws IOException

Retrieves the body of the request as character data using a BufferedReader. The reader translates the character data according to the character encoding used on the body. Either this method or getReader() may be called to read the body, not both.

Specified by:
getReader in interface ServletRequest
Returns:
A BufferedReader containing the body of the request.
Throws:
IOException - if an input or output exception occurred.
IOException
Since:
J2SE 1.3

getRemoteAddr

public String getRemoteAddr()

Returns the Internet Protocol (IP) address of the client that sent the request. For HTTP servlets, same as the value of the CGI variable REMOTE_ADDR.

Specified by:
getRemoteAddr in interface ServletRequest
Returns:
A String containing the IP address of the client that sent the request.
Since:
J2SE 1.3

getRemoteHost

public String getRemoteHost()

Returns the fully qualified name of the client that sent the request, or the IP address of the client if the name cannot be determined. For HTTP servlets, same as the value of the CGI variable REMOTE_HOST.

Specified by:
getRemoteHost in interface ServletRequest
Returns:
A String containing the fully qualified name of the client.
Since:
J2SE 1.3

setAttribute

public void setAttribute(String name,
                         Object o)

Stores an attribute in this request. Attributes are reset between requests. This method is most often used in conjunction with RequestDispatcher .

Attribute names should follow the same conventions as package names. Names beginning with java.*, javax.*, and com.sun.*, are reserved for use by Sun Microsystems.

Specified by:
setAttribute in interface ServletRequest
Since:
J2SE 1.3

removeAttribute

public void removeAttribute(String name)

Removes an attribute from this request. This method is not generally needed as attributes only persist as long as the request is being handled.

Attribute names should follow the same conventions as package names. Names beginning with java.*, javax.*, and com.sun.*, are reserved for use by Sun Microsystems.

Specified by:
removeAttribute in interface ServletRequest
Since:
J2SE 1.3

getLocale

public Locale getLocale()

Returns the preferred Locale that the client will accept content in, based on the Accept-Language header. If the client request doesn't provide an Accept-Language header, this method returns the default locale for the server.

Specified by:
getLocale in interface ServletRequest
Returns:
The preferred Locale for the client.
Since:
J2SE 1.3

getLocales

public Enumeration getLocales()

Returns an Enumeration of Locale objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header.

If the client request doesn't provide an Accept-Language header, this method returns an Enumeration containing one Locale, the default locale for the server.

Specified by:
getLocales in interface ServletRequest
Returns:
An Enumerationof preferred Locale objects for the client.
Since:
J2SE 1.3

isSecure

public boolean isSecure()

Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.

Specified by:
isSecure in interface ServletRequest
Returns:
A boolean indicating if the request was made using a secure channel.
Since:
J2SE 1.3

getRequestDispatcher

public RequestDispatcher getRequestDispatcher(String path)

Returns a RequestDispatcher object that acts as a wrapper for the resource located at the given path. A RequestDispatcher object can be used to forward a request to the resource or to include the resource in a response. The resource can be dynamic or static.

The pathname specified may be relative, although it cannot extend outside the current servlet context. If the path begins with a "/" it is interpreted as relative to the current context root. This method returns null if the servlet container cannot return a RequestDispatcher.

The difference between this method and ServletContext.getRequestDispatcher(java.lang.String) is that this method can take a relative path.

Specified by:
getRequestDispatcher in interface ServletRequest
Returns:
A RequestDispatcher object that acts as a wrapper for the resource at the specified path.
Since:
J2SE 1.3

getRequestURL

public StringBuffer getRequestURL()

Reconstructs the URL the client used to make the request. The returned URL contains a protocol, server name, port number, and server path, but it does not include query string parameters.

Because this method returns a StringBuffer, not a string, you can modify the URL easily, for example, to append query parameters.

This method is useful for creating redirect messages and for reporting errors.

Specified by:
getRequestURL in interface HttpServletRequest
Returns:
A StringBuffer object containing the reconstructed URL.
Since:
Servlet 2.3

getParameterMap

public Map getParameterMap()

Returns a java.util.Map of the parameters of this request. Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

Specified by:
getParameterMap in interface ServletRequest
Returns:
A Map containing parameter names as keys and parameter values as map values. The keys in the parameter map are of type String. The values in the parameter map are of type String array.
Since:
Servlet 2.3

setCharacterEncoding

public void setCharacterEncoding(String env)
                          throws UnsupportedEncodingException

Overrides the name of the character encoding used in the body of this request. This method must be called prior to reading request parameters or reading input using getReader().

Specified by:
setCharacterEncoding in interface ServletRequest
UnsupportedEncodingException
Since:
Servlet 2.3

getRealPath

public String getRealPath(String path)
Deprecated. As of Version 2.1 of the Java Servlet API, use ServletContext.getRealPath(java.lang.String) instead.

Specified by:
getRealPath in interface ServletRequest

OpMath

Submit a bug or feature to Open Math
Copyright © 2002 Open Math Company Limited, Brighton, UK